#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#pragma comment (lib, "winmm.lib")

#define TEMPO	500000

enum {
	ERR_NON,
	ERR_FORMAT
};

typedef struct midi_data {
	int time;
	unsigned char stat;
	unsigned char param1;
	unsigned char param2;
	unsigned char *param3;
	struct midi_data *next;
}DATA;

typedef struct midi_head {
	char type[4];
	int len;
	unsigned short format;
	unsigned short num;
	unsigned short time;
}HEAD;

typedef struct midi_track {
	char type[4];
	unsigned int len;
	DATA *data;
	double time;
}TRACK;

typedef struct midi {
	HEAD *head;
	TRACK *track;
}MIDI;


void SetAppDir(void){
	char str[256];
	int i;

	GetModuleFileName(NULL,str,256);
	i = strlen(str)-1;
	while(str[i] != '\\' && str[i] != '/' && i > 0)i--;
	str[i] = '\0';
	SetCurrentDirectory(str);
}

//ftHgw\atoi
int atoi2(char *str,int def){
	int i;

	if(!isdigit(str[0]))return def;
	i = atoi(str);
	if(i == 0 && str[0] != '0')return def;

	return i;
}

void rev(void *a,int len){							//oCg](oCgI[_[)
	char t,*s,*b;

	s = (char *)a;
	b = s+len-1;
	while(s < b){
		t = *s;
		*s = *b;
		*b = t;
		s++;
		b--;
	}
}

void err(int num){								//errbZ[WóAʂɏĂ邩͂⑶݈Ӌ`͂Ȃ
	if(num == ERR_NON){
		printf("ȏɎs܂\n");
		getchar();
		exit(1);
	}
	if(num == ERR_FORMAT)printf("Ή̃tH[}bgł\nǂݍ݂Ɏs邩炩̏񂪌\܂\n");
}

void MidiPlay(MIDI *midi,double start,int dev){
	MIDIHDR mh;
	HMIDIOUT hmo;
	DATA *a;
	int tempo,delta,msg,len,b;
	char *str;
	double time,t;
	unsigned int t1,t2;

	if(midi->head->format != 0){
		printf("̃vO̓tH[}bg0ȊOmidiĐ͖ΉłB\n");
		return;
	}

	timeBeginPeriod(1);
	printf("midi̍ĐJn܂\n");
	if(MMSYSERR_NOERROR != midiOutOpen(&hmo, dev, 0, 0, CALLBACK_NULL)){
		printf("foCX̃I[vɎs܂\n");
		err(ERR_NON);
	}
	memset(&mh,0,sizeof(MIDIHDR));
	t1 = timeGetTime();
//	while(1){
		midiOutReset(hmo);
		tempo = TEMPO;
		delta = midi->head->time;
		a = midi->track[0].data;
		time = 0.0;

		while(a != NULL){
			t = a->time*(tempo/1000.0)/delta;
			t2 = timeGetTime()-t1;
			t1 += t;
			if(t2>0 && t2<1000)t -= t2;
			if(time >= start){
				if(t>2)Sleep(t-2);
				while(t1 > timeGetTime()){}
				printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%d:%02d:%02d/%d:%02d:%02d",(int)floor(time/60/60),(int)floor(time/60)%60,(int)floor(time)%60,(int)floor(midi->track[0].time/60/60),(int)floor(midi->track[0].time/60)%60,(int)floor(midi->track[0].time)%60);
			}
			time += t/1000;
			if (a->stat == 0xFF) {					//^Cxg
				if(a->param1 == 0x2F){				//GhIugbN
					break;
				} else if(a->param1 == 0x51){			// Zbge|
					tempo = a->param3[2] + (a->param3[1] << 8) + (a->param3[0] << 16);
				}
			} else if (a->stat >= 0xF0) {				//SysExCxg
				switch(a->stat){
					case 0xF0:
						len = a->param1+1;
						str = malloc(len);
						str[0] = a->stat;
						memcpy(&str[1],a->param3,a->param1);
						break;
					case 0xF7:
						len = a->param1;
						str = malloc(len);
						memcpy(str,a->param3,a->param1);
						break;
					default:
						printf("ΉSysExCxgɑ܂\n");
						err(ERR_NON);
						break;
				}
				mh.lpData          = str;
				mh.dwFlags         = 0;
				mh.dwBufferLength  = len;
				mh.dwBytesRecorded = len;

				if(MMSYSERR_NOERROR != midiOutPrepareHeader(hmo, &mh, sizeof(MIDIHDR))){
					printf("\nrobt@擾ł܂łB\nSysExCxgsł܂B\n");
					err(ERR_NON);
				} else {
					midiOutLongMsg(hmo,&mh,sizeof(MIDIHDR));

					while ((mh.dwFlags & MHDR_DONE) == 0);

					while(MMSYSERR_NOERROR != (b = midiOutUnprepareHeader(hmo,&mh,sizeof(MIDIHDR))) ){
						if(b != MIDIERR_STILLPLAYING){
							printf("SysExߎsɃG[܂B\n");
							err(ERR_NON);
						}
					}
				}
			} else {						//MIDICxg
				b = a->stat&0xF0;				//Bx Cx DxñCxg͒ʂĂȂƊy񂪂Ȃ
				if(b==0xB0 || b==0xC0 || b==0xE0 ||time >= start){
					msg = a->stat + (a->param1 << 8) | (a->param2 << 16);
					midiOutShortMsg(hmo, msg);
				}
			}

			a = a->next;
		}
//	}
	midiOutReset(hmo);							//Ô
	midiOutClose(hmo);
	printf("\nĐI܂\n");
	timeEndPeriod(1);
}


int track2bin(DATA *head,FILE *fp){						//loadtrack̋tAgbNf[^Ƀt@Co͂
	unsigned int t,temp,count,start;
	DATA *a;

	start = ftell(fp);							//ݕvp

	a = head;
	while(a != NULL){
		t = 0xFE00000;							//f^^C
		count = 21;
		while(1){
			if(a->time&t || count == 0){
				while(1){
					temp = ((a->time&t)>>count);
					if(count)temp += 128;
					fwrite(&temp,1,1,fp);
					if(!count)break;
					t = t >> 7;
					count -= 7;
				}
				break;
			}
			t = t >> 7;
			count -= 7;
		}

		fwrite(&a->stat,1,1,fp);					//Cxg
		fwrite(&a->param1,1,1,fp);
		switch(a->stat & 0xF0){
			case 0x80:
			case 0x90:
			case 0xA0:
			case 0xB0:
			case 0xE0:
				fwrite(&a->param2,1,1,fp);
				break;
			case 0xC0:
			case 0xD0:
				break;
			case 0xF0:
				switch(a->stat){
					case 0xF0:
					case 0xF7:
						fwrite(a->param3,1,a->param1,fp);
						break;
					case 0xFF:
						fwrite(&a->param2,1,1,fp);
						fwrite(a->param3,1,a->param2,fp);
						break;
					default:
						printf("Ή̃Cxgł(Xe[^X0x%02x)\n",a->stat);
						err(ERR_NON);
						break;
				}
				break;
			default:
				printf("sȃCxgł(Xe[^X0x%02x)\n",a->stat);
				err(ERR_NON);
				break;
		}
		a = a->next;
	}

	return ftell(fp)-start;
}

void savemidi(char* fn,MIDI *midi){						//loadmidi̋tAmidif[^t@Co͂
	FILE *fp;
	int i,temp,len;
	unsigned char *data;

	fp = fopen(fn,"wb");

	printf("wb_[ݒ\n");
	fwrite("MThd",1,4,fp);							//t@Cwb_
	temp = 0x06000000;							//oCgI[_[tȂ̂
	fwrite(&temp,4,1,fp);
	if(midi->head->format == 0 && midi->head->num > 1){
		printf("\ngbNf[^ُAtH[}bg0ł%d̃gbN͈܂\n",midi->head->num);
		err(ERR_NON);
	}
	if(midi->head->format < 3){
		temp = midi->head->num + midi->head->format*0x10000;
		rev(&temp,4);
		fwrite(&temp,2,2,fp);
	} else {
		printf("Ή̃tH[}bgԍłAmidit@Cł܂\n");
		err(ERR_NON);
	}
	temp = midi->head->time;
	rev(&temp,2);
	fwrite(&temp,2,1,fp);
	printf("wb_[݊\n");

	printf("gbNf[^݂Jn܂\n");
	i = 0;
	while(i < midi->head->num){
		printf("gbN%dł܂...\n",i);
		fwrite("MTrk",1,4,fp);
		temp = 0;
		rev(&temp,4);
		fwrite(&temp,4,1,fp);
		len = track2bin(midi->track[i].data,fp);
		temp = len;
		rev(&temp,4);
		fseek(fp,-(len+4),SEEK_CUR);
		fwrite(&temp,4,1,fp);
		fseek(fp,len,SEEK_CUR);
		printf("gbN%d(TCY%d)݂̏܂\n",i,len);
		i++;
	}
	fclose(fp);
	printf("midit@C%s݂̏܂\n",fn);
}

DATA *loadtrack(TRACK *track,unsigned char *data,int len,int time){				//gbNf[^ǂݍ
	int temp,i,count,tempo;
	unsigned char *p,prev = 0;
	double stime=0.0;
	DATA *head=NULL,*a,*b;

	p = data;
	count = 0;
	tempo = TEMPO;
	while(p < data+len){
		a = malloc(sizeof(DATA));
		if(a == NULL){
			printf("[܂\n");
			err(ERR_NON);
		}
		if(head == NULL){
			head = a;
		} else {
			b->next = a;
		}
		b = a;
		b->param3 = NULL;

		b->time = 0;							//f^^Cǂݍ
		do{
			temp = *p;
			b->time = (b->time<<7)+(temp&0x7F);
			p++;
		}while(temp&0x80);
		b->stat = *p;							//Xe[^XR[hǂݍ
		p++;

		if(b->stat&0x80){						//jOXe[^Xp̕
			b->param1 = *p;
			p++;
			prev = b->stat;
		} else {
			b->param1 = b->stat;
			b->stat = prev;
		}
		switch(b->stat & 0xF0){
			case 0x80:
			case 0x90:
			case 0xA0:
			case 0xB0:
			case 0xE0:
				b->param2 = *p;
				p++;
				break;
			case 0xC0:
			case 0xD0:
				b->param2 = 0;
				break;
			case 0xF0:
				switch(b->stat){
					case 0xF0:
					case 0xF7:
						b->param2 = 0;
						b->param3 = malloc(b->param1);
						memcpy(b->param3,p,b->param1);
						p+=b->param1;
						break;
					case 0xFF:
						b->param2 = *p;
						p++;
						b->param3 = malloc(b->param2);
						memcpy(b->param3,p,b->param2);
						p+=b->param2;
						if(a->param1 == 0x51){		//Zbge|
							tempo = a->param3[2] + (a->param3[1] << 8) + (a->param3[0] << 16);
						}
						break;
					default:
						break;
				}
				break;
			default:
				printf("sȃgbNł(Xe[^X%02x:AhX%d)\n",b->stat,p);
				p-=10;
				i = 0;
				printf("ȉfobOpóF");
				while(i < 10){
					printf("%02x ",*p++);
					i++;
				}
				err(ERR_NON);
				break;
		}
		stime += b->time*(tempo/1000.0)/time;
		count++;
		if(b->stat == 0xFF && b->param1 == 0x2F)break;
	}
	if(p < data+len)printf("ɓǂݍ߂܂gbN̒ݒlƈႢ܂(ݒl%d:%d)\n",len,p-data);
	else if(p > data+len)printf("gbNɏIĂ܂(ݒl%d:%d)\n",len,p-data);
	b->next = NULL;
	printf("CxgF%d\ntԁF%lfb\n",count,stime/1000.0);
	track->data = head;
	track->time = stime/1000.0;
	return head;
}

MIDI *loadmidi(char fname[]){							//midiǂݍ
	MIDI *midi;
	FILE *fp;
	int i,temp;
	unsigned char *data;

	midi = (MIDI *)malloc(sizeof(MIDI));
	midi->head = (HEAD *)malloc(sizeof(HEAD));

	fp = fopen(fname,"rb");

	printf("wb_[͒");
	fread(midi->head->type,1,4,fp);						//t@Cwb_ǂݍ
	if(strncmp(midi->head->type,"MThd",4)){
		printf("\nʎqMThdFł܂ł(%s)\n",midi->head->type);
		err(ERR_NON);
	}
	printf(".");
	fread(&(midi->head->len),4,1,fp);
	rev(&(midi->head->len),4);
	if(midi->head->len != 6){
		printf("\nwb_TCYُ(%dbyte)\n",midi->head->len);
		err(ERR_NON);
	}
	printf(".");
	fread(&(midi->head->format),2,1,fp);
	rev(&(midi->head->format),2);
	if(midi->head->format > 2){
		printf("\ntH[}bgُ(type%dΉ)\n",midi->head->format);
		err(ERR_NON);
	}
	printf(".");
	fread(&(midi->head->num),2,1,fp);
	rev(&(midi->head->num),2);
	if(midi->head->format == 0 && midi->head->num > 1){
		printf("\ngbNf[^ُAtH[}bg0ł%d̃gbN͈܂\n",midi->head->num);
		err(ERR_NON);
	}
	printf(".");
	fread(&(midi->head->time),2,1,fp);
	rev(&(midi->head->time),2);

	printf("\ngbNf[^擾...\n");
	midi->track = (TRACK *)malloc(sizeof(TRACK)*midi->head->num);
	if(midi->track == NULL){
		printf("[mۂɎs܂AgbN邩gp\[܂\n");
		err(ERR_NON);
	}
	i = 0;
	while(i < midi->head->num){
		printf("gbN%dǂݍł܂...\n",i);
		fread(midi->track[i].type,1,4,fp);
		if(strncmp(midi->track[i].type,"MTrk",4)){
			printf("ʎqMTrkFł܂ł(%s)\n",midi->track[i].type);
			err(ERR_NON);
		}
		fread(&(midi->track[i].len),4,1,fp);
		rev(&(midi->track[i].len),4);
		if(midi->track[i].len == 0){
			printf("gbN%dɂ͉f[^݂܂\n",i);
			midi->track[i].data = NULL;
		} else {
			data = (unsigned char *)malloc(midi->track[i].len);
			fread(data,1,midi->track[i].len,fp);
			loadtrack(&midi->track[i],data,midi->track[i].len,midi->head->time);
		}
		i++;
	}

	temp = ftell(fp);
	fseek(fp,0,SEEK_END);
	if(temp != ftell(fp))printf("t@CɎgpĂȂoCg񂪑݂܂(TCY%d)\n",ftell(fp)-temp);
	fclose(fp);
	printf("midit@C%s̓ǂݍ݂܂\n\n",fname);
	printf("tH[}bgF%d\ngbNF%d\n",midi->head->format,midi->head->num);
	i = 0;
	while(i < midi->head->num){
		printf("gbN%dF%dbyte\n",i,midi->track[i].len);
		i++;
	}
	printf("\n");
	return midi;
}

void print_dev_info(int n){							//foCX񋓁AꕔđSRsy
	int temp;
	MIDIOUTCAPS m;
	char s;
	LPTSTR lpszTechnology[] = {
			"MIDI hardware port",
			"synthesizer",
			"square wave synthesizer",
			"FM synthesizer",
			"Microsoft MIDI mapper",
			"hardware wavetable synthesizer",
			"software synthesizer"
		};

	if(MMSYSERR_NOERROR != (temp = midiOutGetDevCaps(n,&m,sizeof(MIDIOUTCAPS)))){
		printf("݂ȂfoCXԍł(G[%d)\n",temp);
		return;
	}
	printf("\tManufacturer identifier : %d\n", m.wMid);
	printf("\tProduct identifier : %d\n", m.wPid);
	printf("\tVersion number : %d\n", m.vDriverVersion);
	printf("\tTechnology : %s\n", lpszTechnology[m.wTechnology - 1]);
	printf("\tNumber of voices : %d\n", m.wVoices);
	printf("\tMaximum number of simultaneous notes : %d\n", m.wNotes);
	printf("\tChannels : %d\n", m.wChannelMask);

	if (m.dwSupport & MIDICAPS_VOLUME)
		printf("\tSupports volume control\n");
	if (m.dwSupport & MIDICAPS_LRVOLUME)
		printf("\tSupports separate left and right volume control\n");
	if (m.dwSupport & MIDICAPS_CACHE)
		printf("\tSupports patch caching\n");
	if (m.dwSupport & MIDICAPS_STREAM)
		printf("\tProvides direct support for the midiStreamOut function\n");
	if(m.wTechnology-1 == 0)
		printf("\t̃foCXł͍ĐrɏIłȂȂ鋰ꂪ܂\n");
}

int main(int argc,char *argv[]){
	MIDI *midi;									//ĂœnČn
	char str[256];
	int i,n,dev;

	SetAppDir();

	if(argc < 2)return 0;

	n=midiOutGetNumDevs();
	printf("%d̃foCXo܂\n",n);
	i = n;
	while(i > 0){
		i--;
		printf("foCX%d:\n",i);
		print_dev_info(i);
	}
	if(n == 0){
		printf("MIDI|[g݂Ȃ̂MIDIĐ͍s܂\n");
		dev = -1;
	} else if(n == 1){
		dev = 0;
	} else {
		do{
			printf("gpfoCXԍ͂ĂB\nfoCXԍ:");
			fgets(str,256,stdin);
			dev = atoi2(str,-1);
		}while(dev < 0 || dev >= n);
	}

	n = 1;
	while(n < argc){
		midi = loadmidi(argv[n]);
		sprintf(str,"%s.mid",argv[n]);
		savemidi(str,midi);
		if(dev >= 0)MidiPlay(midi,0,dev);

		i = 0;
		while(i < midi->head->num){
			free(midi->track[i].data);
			i++;
		}
		free(midi->track);
		free(midi->head);
		free(midi);
		n++;
	}
	printf("\nSĂ̏܂AIꍇENTERĂ\n");
	getchar();
	return 0;
}
/*
Em̃oO
midiCxgȊÕCxgf[^jĂĂjOXe[^XƌFēǂݍł܂\oO
SysExCxg̃f[^127oCgȏłƂɐɓǂݏłȂoO
midiwb_̎ԒPʂԎwłꍇɐɓǂݏĐłȂoO
*/

/*
E2009/02/09ǋL
ĐԊǗ̐x
*/

/*
E2008/09/26ǋL
MidiPlayV݁AɔmainɃfoCX֘Aǉ
atoi2V
loadtrack̍ĐԌvŃZbge|ɑΉ
loadtrack̃f[^󂯓n@ύX
TRACK\̂ɍĐԂǉ
err֐̏o͓eύX
*/

/*
E2008/09/25ǋL
G[܂ܕuĂplaytrackP
Lɔĕsvȍ\̂̍폜
loadtrack̃jOXe[^Xɓ삵ĂȂoOC
loadtrackŃ^Cxg̏ɍsĂȂoOC
loadtrackŃGhIugbNȂꍇɐɓǂݍ߂ĂȂs̏C
loadtrackŃf^^C𐳏ɌvZłĂȂs̏C
loadmidiłȂMTrklen4{ĂsC
loadtrack̏𐮗Asvȃ[Jϐ̓P
loadmidĩG[኱ύX
print_dev_infȍo͌`኱ύX
errmainɂgetchar()֐ŃXgbv悤ɕύX
JgfBNgexeuĂtH_ɂȂ悤ύXAɔSetAppDirV
reṽ[vύXAsvȕϐP
savemidiAtrack2binV
*/

/*
E2008/02/12ǋL
playtrackV
*/

/*
E2008/02/11ǋL
loadtrackAprint_dev_infoV
ɔloadmidimainɎ኱̏Cƒǉ
*/

/*
E2008/02/10JJn
e\̂`
mainAloadmidiAerrArevV
*/
